// DiskWriteTimeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DiskWriteTime.h"
#include "DiskWriteTimeDlg.h"
#include "Winbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define FP_Length 100

BYTE data[1024*1024];
BYTE Buffer[4*1024*1024];
TCHAR fileName[250];
TCHAR FilePath[250];
char CFilePath[100];
bool AutoRun;
bool Auto = false;
bool AutoWOK=false;
bool AutoROK=false;
DWORD SingleStart;
DWORD SingleEnd;
DWORD SingleTime;
DWORD WriteLength,ReadLength;
DWORD RWret,DataByte,WriteTime,ReadTime;
DWORD AVGWriteTime,AVGReadTime;

// CDiskWriteTimeDlg dialog

CDiskWriteTimeDlg::CDiskWriteTimeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiskWriteTimeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiskWriteTimeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK5, chkDelete);
	DDX_Control(pDX, IDC_EDIT2, txtFileName);
	DDX_Control(pDX, IDC_LIST1, ListResult);
}

BEGIN_MESSAGE_MAP(CDiskWriteTimeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CDiskWriteTimeDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDiskWriteTimeDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CDiskWriteTimeDlg::singleWrite)
	ON_BN_CLICKED(IDC_CHECK1, &CDiskWriteTimeDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK2, &CDiskWriteTimeDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_CHECK3, &CDiskWriteTimeDlg::OnBnClickedCheck3)
	ON_BN_CLICKED(IDC_CHECK4, &CDiskWriteTimeDlg::OnBnClickedCheck4)
	ON_BN_CLICKED(IDC_BUTTON4, &CDiskWriteTimeDlg::singleRead)
END_MESSAGE_MAP()


// CDiskWriteTimeDlg message handlers

BOOL CDiskWriteTimeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	wsprintf(FilePath,L"/Temp/Test.txt");
	txtFileName.SetWindowTextW(L"data.txt");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CDiskWriteTimeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_DISKWRITETIME_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_DISKWRITETIME_DIALOG));
	}
}
#endif



void DoEvents(){
	MSG msg;
	for(int j=0;j<10;j++){
		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
}


int GetTime(){
	LARGE_INTEGER tt0;
	QueryPerformanceCounter(&tt0);
	return (int)tt0.QuadPart;
}

void SetReadData(int RTime){
	ReadTime = RTime;
}

void SetWriteData(int WTime){
	WriteTime = WTime;
}


void CDiskWriteTimeDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	HANDLE hFile;

	TCHAR Msg[50];
	int i,j,k;
	int Test_Time;
	DWORD Total_WTime,Total_RTime;
	CButton *pButton = NULL;
	TCHAR tcTemp[100]={0};
	CWaitCursor wait;
	DWORD RBtye[] = {1024,2048,4096,8192,16*1024,32*1024,64*1024,128*1024,256*1024,512*1024,
					1024*1024,2048*1024};

	Auto = true;
	AutoRun = true;
	char cBuffer[100];
	TCHAR RPath[100] = TEXT("\\temp\\record.txt");
	DeleteFile(RPath);

	hFile = CreateFile(RPath,GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		wsprintf(Msg,L"Open file %s error",RPath);
		ListResult.AddString(Msg);
		return;
	}else{
		wsprintf(Msg,L"Open file %s ok",RPath);
		ListResult.AddString(Msg);
	}
	for(i=0;i<5;i++){
		if(!AutoRun)
			break;
		
		pButton = ((CButton*) GetDlgItem(IDC_CHECK1+i));

		if(pButton->GetCheck()){
			pButton->GetWindowTextW(FilePath,FP_Length);
			GetDlgItemText(IDC_EDIT2,tcTemp,100);
			wcscat(FilePath,tcTemp);

			for(j=0;j<FP_Length;j++){
				CFilePath[j] = FilePath[j];
			}
			CFilePath[j] = 0;

			for(j=0;j<12;j++){

				if(!AutoRun)
					break;

				AutoROK = false;
				AutoWOK = false;
				DataByte = RBtye[j];
				Test_Time = 1024*1024/DataByte;
				printf("write %s %d byte %d \n",CFilePath,DataByte,Test_Time);
				Total_WTime = 0;
				Total_RTime =0;
				for(k=0;k<Test_Time;k++){
					if(!AutoRun)
						break;
					Sleep(10);
					//wsprintf(Msg,L"write data in %s",FilePath);
					//ListResult.AddString(Msg);
					singleWrite();
					if(!AutoWOK){
						wsprintf(Msg,L"write data error %s %d",FilePath,Test_Time);
						ListResult.AddString(Msg);
						break;
					}
					Total_WTime += WriteTime;
					DoEvents();
					Sleep(10);
					//wsprintf(Msg,L"read data in %s",FilePath);
					//ListResult.AddString(Msg);
					singleRead();
					Total_RTime += ReadTime;
					//printf("Read Time: %d Write Time: %d, Total RTime %d, Total WTime %d\n",ReadTime,WriteTime,Total_RTime,Total_WTime);

				}
				AVGWriteTime = Total_WTime / Test_Time;
				AVGReadTime = Total_RTime /Test_Time;

				if(AutoWOK & AutoROK){
					wsprintf(Msg,L"W/R Target %s ok Data=%d byte WT=%d us RT=%d us ",FilePath,WriteLength,AVGWriteTime,AVGReadTime);
					ListResult.AddString(Msg);
					sprintf(cBuffer,"W/R Target %s ok Write %d times,Data=%d byte WT=%d us RT=%d us\n",CFilePath,Test_Time,WriteLength,AVGWriteTime,AVGReadTime);
					if(!WriteFile(hFile,cBuffer,strlen(cBuffer),&WriteLength,NULL))
						::MessageBox(NULL,L"write record error",L"error",MB_OK);
				}else{
					wsprintf(Msg,L"W/R Target %s error ",FilePath);
					ListResult.AddString(Msg);
					sprintf(cBuffer,"W/R Target %s error \n",FilePath);
					if(!WriteFile(hFile,cBuffer,strlen(cBuffer),&WriteLength,NULL))
						::MessageBox(NULL,L"write record error",L"error",MB_OK);
				}

			}
			DoEvents();
		}
	}
	::MessageBox(NULL,L"exit loop",L"test",MB_OK);
	CloseHandle(hFile);
	::MessageBox(NULL,L"close handle",L"test",MB_OK);
	if(AutoRun){
		wsprintf(Msg,L"W/R Test Normal Stop write data");
	}else{
		wsprintf(Msg,L"W/R Test User Stop write data");
	}

	ListResult.AddString(Msg);
	::MessageBox(NULL,L"add message in list",L"test",MB_OK);
	Auto = false;
	AutoRun = false;
	wait.Restore();
	

}

void CDiskWriteTimeDlg::OnBnClickedButton2()
{
	AutoRun = false;
}


void CDiskWriteTimeDlg::singleWrite()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[50];
	if(chkDelete.GetCheck())
		DeleteFile(FilePath);

	Sleep(100);
	SingleStart = GetTime();
	HANDLE hFile;
	//wprintf(L"file=%s\r\n",FilePath);
	hFile = CreateFile(FilePath,GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		CloseHandle(hFile);
		ListResult.AddString(L"create file error");
		::MessageBox(NULL,L"create file error",L"TEST",MB_OK);
		return ;
	}
	RWret = WriteFile(hFile,Buffer,DataByte,&WriteLength,NULL);
	CloseHandle(hFile);

	SingleEnd = GetTime();
	SingleTime = SingleEnd - SingleStart;

	if(Auto){
		AutoWOK = RWret;
		if(!AutoWOK){
			wsprintf(temp,L"write %s error\n",FilePath);
			//printf("write %s error, DataByte %d , WriteLength %d\n",FilePath,DataByte,WriteLength);
			ListResult.AddString(temp);
		}
		WriteTime = SingleTime;
		SetWriteData(SingleTime);
		//printf("write time %d ,start %d end %d\n",SingleTime,SingleStart,SingleEnd);
	}else{
		if(RWret){
			wsprintf(temp,L"====write %x take %d ms => write file :%s ok====",WriteLength,SingleTime,FilePath);
		}else{
			wsprintf(temp,L"====take %d ms => write file :%s error====",SingleTime,FilePath);
		}
		ListResult.AddString(temp);
	}

}

void CDiskWriteTimeDlg::OnBnClickedCheck1()
{
	// TODO: Add your control notification handler code here
	CString fName;
	txtFileName.GetWindowTextW(fName);
	wsprintf(FilePath,L"\\System_Disk\\%s",fName);
}

void CDiskWriteTimeDlg::OnBnClickedCheck2()
{
	// TODO: Add your control notification handler code here
	CString fName;
	txtFileName.GetWindowTextW(fName);
	wsprintf(FilePath,L"\\System_Disk2\\%s",fName);
}

void CDiskWriteTimeDlg::OnBnClickedCheck3()
{
	// TODO: Add your control notification handler code here
	CString fName;
	txtFileName.GetWindowTextW(fName);
	wsprintf(FilePath,L"\\USB Disk\\%s",fName);
}

void CDiskWriteTimeDlg::OnBnClickedCheck4()
{
	// TODO: Add your control notification handler code here
	CString fName;
	txtFileName.GetWindowTextW(fName);
	wsprintf(FilePath,L"\\Temp\\%s",fName);
}

void CDiskWriteTimeDlg::singleRead()
{
	// TODO: Add your control notification handler code here
	Sleep(100);

	TCHAR temp[50];

	SingleStart = GetTime();
	HANDLE hFile;
	hFile = CreateFile(FilePath,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		CloseHandle(hFile);
		ListResult.AddString(L"create file error");
		return ;
	}

	RWret = ReadFile(hFile,Buffer,DataByte,&ReadLength,NULL);
	CloseHandle(hFile);

	SingleEnd = GetTime();
	SingleTime = SingleEnd - SingleStart;
	if(Auto){
		AutoROK = RWret;
		if(!AutoROK){
			wsprintf(temp,L"read %s error\n",FilePath);
			//printf("read %s error, DataByte %d , ReadLength %d\n",FilePath,DataByte,ReadLength);
			ListResult.AddString(temp);
		}
		ReadTime = SingleTime;
		SetReadData(SingleTime);
		//printf("read time %d ,start %d end %d\n",SingleTime,SingleStart,SingleEnd);
	}else{
		if(RWret){
			wsprintf(temp,L"====read %x take %d ms => write file :%s ok====",ReadLength,SingleTime,FilePath);
		}else{
			wsprintf(temp,L"====read %d ms => read file :%s error====",SingleTime,FilePath);
		}
		ListResult.AddString(temp);
	}

}
