// ActiveDriverName.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ActiveDriverName.h"

int WINAPI WinMain(     HINSTANCE hInstance,
                                                                                HINSTANCE hPrevInstance,
                                                                                LPTSTR    lpCmdLine,
                                                                                int       nCmdShow)
{

	HANDLE hDevice = NULL;
	DeviceSearchType eSearchType = DeviceSearchByLegacyName;
	DEVMGR_DEVICE_INFORMATION sInfo = {0};

	sInfo.dwSize = sizeof(DEVMGR_DEVICE_INFORMATION);
	hDevice = FindFirstDevice(eSearchType,TEXT("*"),&sInfo);

	int nItem = 0;
	int nListItem = 0;

	if(INVALID_HANDLE_VALUE == hDevice)
		return 0;

	BOOL bContinue = TRUE;

	while(bContinue)
	{
		if(wcsstr(TEXT("Drivers\\BuiltIn\\UART5"),sInfo.szDeviceKey)!=NULL)
		{
		wprintf(TEXT("Item=%d\r\n"),nItem);
		wprintf(TEXT("LegacyName=%s\r\n"),sInfo.szLegacyName);
		wprintf(TEXT("DeviceName=%s\r\n"),sInfo.szDeviceName);
		wprintf(TEXT("BusName=%s\r\n"),sInfo.szBusName);	
		wprintf(TEXT("DeviceKey=%s\r\n"),sInfo.szDeviceKey);		
		wprintf(TEXT("hDevice=0x%x\r\n"),sInfo.hDevice);
		}

		++nItem;

		bContinue = FindNextDevice(hDevice,&sInfo);
	}

	FindClose(hDevice);
	return 0;
}
