// MicroSD_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MicroSD_Demo.h"
#include "MicroSD_DemoDlg.h"
#include "pacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMicroSD_DemoDlg dialog

CMicroSD_DemoDlg::CMicroSD_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMicroSD_DemoDlg::IDD, pParent)
{
	m_Results = false;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMicroSD_DemoDlg::DoDataExchange(CDataExchange* pDX)
{	
	CDialog::DoDataExchange(pDX);
	::DDX_Text(pDX, IDC_EDIT1, m_Results);
}

BEGIN_MESSAGE_MAP(CMicroSD_DemoDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMicroSD_DemoDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMicroSD_DemoDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMicroSD_DemoDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMicroSD_DemoDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CMicroSD_DemoDlg message handlers

BOOL CMicroSD_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMicroSD_DemoDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MICROSD_DEMO_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MICROSD_DEMO_DIALOG));
	}
}
#endif


void CMicroSD_DemoDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDMount(TEXT("Part00"));	//the partition name
	UpdateData(false);
}

void CMicroSD_DemoDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDUnmount();
	UpdateData(false);
}

void CMicroSD_DemoDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDExists();
	UpdateData(false);
}

void CMicroSD_DemoDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDOnside();
	UpdateData(false);
}
