﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace NetworkTestServer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        Socket ServerSocket;
        TcpListener ServerListen;
        private void btnStart_Click(object sender, EventArgs e)
        {
            IPAddress IP;
            int loop = 0, size = 0,length=0,dataSize=0 ;
            IP = IPAddress.Parse(txtIP.Text);
            loop = int.Parse(txtLoop.Text);
            int ServerPort = int.Parse(txtPort.Text);
            byte[] data = new byte[32768];
            byte[] recive = new byte[32768];
            String ReciveString = "";

            ServerListen = new TcpListener(IP, ServerPort);
            ServerListen.Start();
            ServerSocket = ServerListen.AcceptSocket();
            txtMessage.Text = "Socket Accept!!";
            Application.DoEvents();
            txtMessage.Text = "listen Client require";
            Application.DoEvents();

            try
            {
                while (true)
                {
                    if (ServerSocket.Connected)
                    {
                        txtMessage.Text = "Connect to Client";
                        Application.DoEvents();

                        size = ServerSocket.Receive(recive);
                        ReciveString = Encoding.ASCII.GetString(data, 0, size);
                        if (ReciveString.IndexOf("OPENNET") >= 0)
                        {
                            int index = ReciveString.IndexOf('_');
                            String temp = ReciveString.Substring(index, ReciveString.Length - index);
                            length = int.Parse(temp);
                        }
                        for (int i = 0; i < length; i++)
                        {
                            data[i] = (byte) (i % 255);

                        }
                        while (loop!=0)
                        {
                            ServerSocket.Send(data);
                            size=0;
                            while (size == 0)
                            {
                                Application.DoEvents();
                                size = ServerSocket.Receive(recive);
                                
                            }
                            ReciveString = Encoding.ASCII.GetString(data, 0, size);
                            if (ReciveString.IndexOf("CHECKOK") >= 0)
                            {
                                ServerSocket.Send(data);
                            }
                            loop--;
                        }
                        recive = Encoding.ASCII.GetBytes("TESTEND");
                        ServerSocket.Send(recive);
                        if (loop == 0)
                            break;
                    }
                }
                txtMessage.Text = "Test finish";

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            //close network port
            ServerSocket.Close();
            ServerListen.Stop();
        }
    }
}